Index: admin/settings/grades.php
=========================================================
--- admin/settings/grades.php	(revision 1.14.2.20)
+++ admin/settings/grades.php	Thu Apr 16 09:31:42 CEST 2009
@@ -54,8 +54,14 @@
                                                          '3' => '3',
                                                          '4' => '4',
                                                          '5' => '5')));
+        $temp->add(new admin_setting_configselect('grade_navmethod', get_string('navmethod', 'grades'), null, 0,
+                                                  array(GRADE_NAVMETHOD_DROPDOWN => get_string('dropdown', 'grades'),
+                                                        GRADE_NAVMETHOD_TABS => get_string('tabs', 'grades'),
+                                                        GRADE_NAVMETHOD_COMBO => get_string('combo', 'grades'))));
 
         $temp->add(new admin_setting_special_gradeexport());
+
+        $temp->add(new admin_setting_special_gradelimiting());
     }
     $ADMIN->add('grades', $temp);
 
@@ -76,9 +82,17 @@
                          GRADE_AGGREGATE_MAX             =>get_string('aggregatemax', 'grades'),
                          GRADE_AGGREGATE_MODE            =>get_string('aggregatemode', 'grades'),
                          GRADE_AGGREGATE_SUM             =>get_string('aggregatesum', 'grades'));
+
+        $defaultvisible = array(GRADE_AGGREGATE_MEAN, GRADE_AGGREGATE_WEIGHTED_MEAN, GRADE_AGGREGATE_WEIGHTED_MEAN2,
+                                GRADE_AGGREGATE_EXTRACREDIT_MEAN, GRADE_AGGREGATE_MEDIAN, GRADE_AGGREGATE_MIN,
+                                GRADE_AGGREGATE_MAX, GRADE_AGGREGATE_MODE, GRADE_AGGREGATE_SUM);
+
         $defaults = array('value'=>GRADE_AGGREGATE_WEIGHTED_MEAN2, 'forced'=>false, 'adv'=>false);
         $temp->add(new admin_setting_gradecat_combo('grade_aggregation', get_string('aggregation', 'grades'), get_string('aggregationhelp', 'grades'), $defaults, $options));
 
+        $temp->add(new admin_setting_configmultiselect('grade_aggregations_visible', get_string('aggregationsvisible', 'grades'),
+                                                       get_string('aggregationsvisiblehelp', 'grades'), $defaultvisible, $options));
+
         $options = array(0 => get_string('no'), 1 => get_string('yes'));
 
         $defaults = array('value'=>1, 'forced'=>false, 'adv'=>true);
Index: grade/edit/letter/edit.php
=========================================================
--- grade/edit/letter/edit.php	(revision 1.3.2.2)
+++ grade/edit/letter/edit.php	Thu Apr 16 09:31:42 CEST 2009
@@ -133,12 +133,7 @@
     admin_externalpage_print_header();
 
 } else {
-    $navigation = grade_build_nav(__FILE__, $pagename, $COURSE->id);
-    /// Print header
-    print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($COURSE));
-
-    $currenttab = 'lettersedit';
-    require('tabs.php');
+    print_grade_page_head($COURSE->id, 'letter', 'edit', get_string('editgradeletters', 'grades'));
 }
 
 $mform->display();
Index: grade/edit/letter/index.php
=========================================================
--- grade/edit/letter/index.php	(revision 1.4)
+++ grade/edit/letter/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -45,15 +45,7 @@
 $strgrades = get_string('grades');
 $pagename  = get_string('letters', 'grades');
 
-$navigation = grade_build_nav(__FILE__, $pagename, $courseid);
-
-/// Print header
-print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-/// Print the plugin selector at the top
-print_grade_plugin_selector($courseid, 'edit', 'letter');
-
-$currenttab = 'lettersview';
-require('tabs.php');
+print_grade_page_head($courseid, 'letter', 'view', get_string('gradeletters', 'grades'));
 
 $letters = grade_get_letters($context);
 
Index: grade/edit/outcome/course.php
=========================================================
--- grade/edit/outcome/course.php	(revision 1.6.2.1)
+++ grade/edit/outcome/course.php	Thu Apr 16 09:31:42 CEST 2009
@@ -132,26 +132,8 @@
     redirect('course.php?id='.$courseid); // we must redirect to get fresh data
 }
 
-$strgrades = get_string('grades');
-$pagename  = get_string('outcomescourse', 'grades');
-
-$navlinks = array(array('name'=>$strgrades,
-                        'link'=>$CFG->wwwroot.'/grade/index.php?id='.$courseid,
-                        'type'=>'misc'),
-                  array('name'=>$pagename,
-                        'link'=>'',
-                        'type'=>'misc')
-                 );
-$navigation = build_navigation($navlinks);
-$navigation = grade_build_nav(__FILE__, $pagename, $courseid);
 /// Print header
-print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-
-/// Print the plugin selector at the top
-print_grade_plugin_selector($courseid, 'edit', 'outcome');
-
-$currenttab = 'courseoutcomes';
-require('tabs.php');
+print_grade_page_head($COURSE->id, 'outcome', 'course');
 
 check_theme_arrows();
 require('course_form.html');
Index: grade/edit/outcome/edit.php
=========================================================
--- grade/edit/outcome/edit.php	(revision 1.4.2.2)
+++ grade/edit/outcome/edit.php	Thu Apr 16 09:31:42 CEST 2009
@@ -32,9 +32,12 @@
 $id       = optional_param('id', 0, PARAM_INT);
 
 $systemcontext = get_context_instance(CONTEXT_SYSTEM);
+$heading = null;
 
 // a bit complex access control :-O
 if ($id) {
+    $heading = get_string('editoutcome', 'grades');
+
     /// editing existing outcome
     if (!$outcome_rec = get_record('grade_outcomes', 'id', $id)) {
         error('Incorrect outcome id');
@@ -61,6 +64,7 @@
     }
 
 } else if ($courseid){
+    $heading = get_string('addoutcome', 'grades');
     /// adding new outcome from course
     if (!$course = get_record('course', 'id', $courseid)) {
         print_error('nocourseid');
@@ -119,14 +123,8 @@
     redirect($returnurl);
 }
 
-$strgrades       = get_string('grades');
-$strgraderreport = get_string('graderreport', 'grades');
-$stroutcomeedit  = get_string('outcome', 'grades');
-
 if ($courseid) {
-    $navigation = grade_build_nav(__FILE__, $stroutcomeedit, array('courseid' => $courseid));
-    print_header_simple($strgrades.': '.$strgraderreport, ': '.$stroutcomeedit, $navigation, '', '', true, '', navmenu($course));
-
+    print_grade_page_head($courseid, 'outcome', 'edit', $heading);
 } else {
     require_once $CFG->libdir.'/adminlib.php';
     admin_externalpage_setup('outcomes');
Index: grade/edit/outcome/import.php
=========================================================
--- grade/edit/outcome/import.php	(revision 1.1.2.6)
+++ grade/edit/outcome/import.php	Thu Apr 16 09:31:42 CEST 2009
@@ -79,16 +79,11 @@
 $caneditsystemscales = has_capability('moodle/course:managescales', $systemcontext);
 
 if ($courseid) {
-    /// Print header
-    print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-    /// Print the plugin selector at the top
-    print_grade_plugin_selector($courseid, 'edit', 'outcome');
+
+    print_grade_page_head($courseid, 'outcome', 'import', get_string('importoutcomes', 'grades'));
 
     $caneditcoursescales = has_capability('moodle/course:managescales', $context);
 
-    $currenttab = 'outcomes';
-    require('tabs.php');
-
 } else {
     admin_externalpage_print_header();
     $caneditcoursescales = $caneditsystemscales;
@@ -208,7 +203,7 @@
             print_box(get_string('importskippedoutcome', 'grades', $csv_data[$imported_headers['outcome_shortname']]));
             continue;
         }
-
+        break;
         // new outcome will be added, search for compatible existing scale...
         $scale = get_records_select('scale', 'name ="'. $csv_data[$imported_headers['scale_name']] .'" and scale ="'. $csv_data[$imported_headers['scale_items']] .'" and (courseid = '. $courseid .' or courseid = 0)');
 
Index: grade/edit/outcome/index.php
=========================================================
--- grade/edit/outcome/index.php	(revision 1.10.2.6)
+++ grade/edit/outcome/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -125,16 +125,9 @@
 $caneditsystemscales = has_capability('moodle/course:managescales', $systemcontext);
 
 if ($courseid) {
-    /// Print header
-    print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-    /// Print the plugin selector at the top
-    print_grade_plugin_selector($courseid, 'edit', 'outcome');
 
     $caneditcoursescales = has_capability('moodle/course:managescales', $context);
 
-    $currenttab = 'outcomes';
-    require('tabs.php');
-
 } else {
     admin_externalpage_print_header();
     $caneditcoursescales = $caneditsystemscales;
@@ -142,10 +135,10 @@
 
 
 $outcomes_tables = array();
+$heading = get_string('outcomes', 'grades');
 
 if ($courseid and $outcomes = grade_outcome::fetch_all_local($courseid)) {
-
-    $return = print_heading($strcustomoutcomes, '', 2, 'main', true);
+    $return = print_heading($strcustomoutcomes, '', 3, 'main', true);
     $data = array();
     foreach($outcomes as $outcome) {
         $line = array();
@@ -253,6 +246,11 @@
     $outcomes_tables[] = $return;
 }
 
+if ($courseid) {
+    /// Print header
+    print_grade_page_head($courseid, 'outcome', 'edit', $heading);
+}
+
 foreach($outcomes_tables as $table) {
     print($table);
 }
Index: grade/edit/scale/edit.php
=========================================================
--- grade/edit/scale/edit.php	(revision 1.6.2.1)
+++ grade/edit/scale/edit.php	Thu Apr 16 09:31:42 CEST 2009
@@ -32,9 +32,12 @@
 $id       = optional_param('id', 0, PARAM_INT);
 
 $systemcontext = get_context_instance(CONTEXT_SYSTEM);
+$heading = '';
 
 // a bit complex access control :-O
 if ($id) {
+    $heading = get_string('editscale', 'grades');
+
     /// editing existing scale
     if (!$scale_rec = get_record('scale', 'id', $id)) {
         error('Incorrect scale id');
@@ -61,6 +64,7 @@
     }
 
 } else if ($courseid){
+    $heading = get_string('addscale', 'grades');
     /// adding new scale from course
     if (!$course = get_record('course', 'id', $courseid)) {
         print_error('nocourseid');
@@ -112,21 +116,15 @@
         }
         $scale->update();
     }
-
     redirect($returnurl);
 }
 
-$strgrades       = get_string('grades');
-$strgraderreport = get_string('graderreport', 'grades');
-$strscaleedit    = get_string('scale');
-
 if ($courseid) {
-    $navigation = grade_build_nav(__FILE__, $strscaleedit, $courseid);
-    print_header_simple($strgrades.': '.$strgraderreport, ': '.$strscaleedit, $navigation, '', '', true, '', navmenu($course));
+    print_grade_page_head($course->id, 'scale', 'edit', $heading);
 
 } else {
     require_once $CFG->libdir.'/adminlib.php';
-    admin_externalpage_setup('outcomes');
+    admin_externalpage_setup('scales');
     admin_externalpage_print_header();
 }
 
Index: grade/edit/scale/edit_form.php
=========================================================
--- grade/edit/scale/edit_form.php	(revision 1.10.2.2)
+++ grade/edit/scale/edit_form.php	Thu Apr 16 09:31:42 CEST 2009
@@ -143,7 +143,7 @@
 
             $options = explode(',', $data['scale']);
             if (count($options) < 2) {
-                $errors['scale'] = get_string('error');
+                $errors['scale'] = get_string('badlyformattedscale', 'grades');
             }
         }
 
Index: grade/edit/scale/index.php
=========================================================
--- grade/edit/scale/index.php	(revision 1.6)
+++ grade/edit/scale/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -47,12 +47,6 @@
 /// return tracking object
 $gpr = new grade_plugin_return(array('type'=>'edit', 'plugin'=>'scale', 'courseid'=>$courseid));
 
-
-$strgrades = get_string('grades');
-$pagename  = get_string('scales');
-
-$navigation = grade_build_nav(__FILE__, $pagename, array('courseid' => $courseid));
-
 $strscale          = get_string('scale');
 $strstandardscale  = get_string('scalesstandard');
 $strcustomscales   = get_string('scalescustom');
@@ -88,18 +82,17 @@
         break;
 }
 
-if ($courseid) {
-    /// Print header
-    print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-    /// Print the plugin selector at the top
-    print_grade_plugin_selector($courseid, 'edit', 'scale');
-
-} else {
+if (!$courseid) {
     admin_externalpage_print_header();
 }
 
+$table = null;
+$table2 = null;
+$heading = '';
+
 if ($courseid and $scales = grade_scale::fetch_all_local($courseid)) {
-    print_heading($strcustomscales);
+    $heading = $strcustomscales;
+
     $data = array();
     foreach($scales as $scale) {
         $line = array();
@@ -123,11 +116,11 @@
     $table->align = array('left', 'center', 'center');
     $table->width = '90%';
     $table->data  = $data;
-    print_table($table);
 }
 
 if ($scales = grade_scale::fetch_all_global()) {
-    print_heading($strstandardscale);
+    $heading = $strstandardscale;
+
     $data = array();
     foreach($scales as $scale) {
         $line = array();
@@ -148,14 +141,22 @@
         $line[] = $buttons;
         $data[] = $line;
     }
-    $table->head  = array($strscale, $strused, $stredit);
-    $table->size  = array('70%', '20%', '10%');
-    $table->align = array('left', 'center', 'center');
-    $table->width = '90%';
-    $table->data  = $data;
-    print_table($table);
+    $table2->head  = array($strscale, $strused, $stredit);
+    $table2->size  = array('70%', '20%', '10%');
+    $table2->align = array('left', 'center', 'center');
+    $table2->width = '90%';
+    $table2->data  = $data;
 }
 
+
+if ($courseid) {
+    print_grade_page_head($courseid, 'scale', null, get_string('coursescales', 'grades'));
+}
+
+print_heading($strcustomscales, '', 3, 'main');
+print_table($table);
+print_heading($strstandardscale, '', 3, 'main');
+print_table($table2);
 echo '<div class="buttons">';
 print_single_button('edit.php', array('courseid'=>$courseid), $srtcreatenewscale);
 echo '</div>';
Index: grade/edit/settings/index.php
=========================================================
--- grade/edit/settings/index.php	(revision 1.3.2.1)
+++ grade/edit/settings/index.php	Thu Apr 16 09:31:42 CEST 2009
@@ -74,10 +74,11 @@
     redirect($returnurl);
 }
 
-/// Print header
-print_header_simple($strgrades.': '.$pagename, ': '.$strgrades, $navigation, '', '', true, '', navmenu($course));
-/// Print the plugin selector at the top
-print_grade_plugin_selector($courseid, 'edit', 'settings');
+print_grade_page_head($courseid, 'settings', 'coursesettings', get_string('coursesettings', 'grades'));
+
+print_box_start('generalbox boxaligncenter boxwidthnormal centerpara');
+echo get_string('coursesettingsexplanation', 'grades');
+print_box_end();
 
 $mform->display();
 
Index: grade/edit/tree/category.php
=========================================================
--- grade/edit/tree/category.php	(revision 1.4.2.6)
+++ grade/edit/tree/category.php	Thu Apr 16 09:31:42 CEST 2009
@@ -29,7 +29,7 @@
 require_once 'category_form.php';
 
 $courseid = required_param('courseid', PARAM_INT);
-$id       = optional_param('id', 0, PARAM_INT);
+$id       = optional_param('id', 0, PARAM_INT); // grade_category->id
 
 if (!$course = get_record('course', 'id', $courseid)) {
     print_error('nocourseid');
@@ -45,6 +45,7 @@
 
 
 $mform = new edit_category_form(null, array('gpr'=>$gpr));
+$heading = get_string('categoryedit', 'grades');
 
 if ($id) {
     if (!$grade_category = grade_category::fetch(array('id'=>$id, 'courseid'=>$course->id))) {
@@ -54,19 +55,20 @@
     $category = $grade_category->get_record_data();
     // Get Category preferences
     $category->pref_aggregationview = grade_report::get_pref('aggregationview', $id);
-    // Load agg coef
-    $grade_item = $grade_category->load_grade_item();
-    $category->aggregationcoef = format_float($grade_item->aggregationcoef, 4);
     // set parent
     $category->parentcategory = $grade_category->parent;
+    $grade_item = $grade_category->load_grade_item();
+    foreach ($grade_item as $key => $value) {
+        $category->{"grade_item_$key"} = $value;
+    }
 
 } else {
+    $heading = get_string('newcategory', 'grades');
     $grade_category = new grade_category(array('courseid'=>$courseid), false);
     $grade_category->apply_default_settings();
     $grade_category->apply_forced_settings();
 
     $category = $grade_category->get_record_data();
-    $category->aggregationcoef = format_float(0, 4);
 }
 
 $mform->set_data($category);
@@ -88,6 +90,7 @@
     }
     grade_category::set_properties($grade_category, $data);
 
+    /// CATEGORY
     if (empty($grade_category->id)) {
         $grade_category->insert();
 
@@ -95,6 +98,79 @@
         $grade_category->update();
     }
 
+    /// GRADE ITEM
+    // grade item data saved with prefix "grade_item_"
+    $itemdata = new stdClass();
+    foreach ($data as $k => $v) {
+        if (preg_match('/grade_item_(.*)/', $k, $matches)) {
+            $itemdata->{$matches[1]} = $v;
+        }
+    }
+
+    if (!isset($itemdata->aggregationcoef)) {
+        $itemdata->aggregationcoef = 0;
+    }
+
+    $hidden      = empty($itemdata->hidden) ? 0: $itemdata->hidden;
+    $hiddenuntil = empty($itemdata->hiddenuntil) ? 0: $itemdata->hiddenuntil;
+    unset($itemdata->hidden);
+    unset($itemdata->hiddenuntil);
+
+    $locked   = empty($itemdata->locked) ? 0: $itemdata->locked;
+    $locktime = empty($itemdata->locktime) ? 0: $itemdata->locktime;
+    unset($itemdata->locked);
+    unset($itemdata->locktime);
+
+    $convert = array('grademax', 'grademin', 'gradepass', 'multfactor', 'plusfactor', 'aggregationcoef');
+    foreach ($convert as $param) {
+        if (array_key_exists($param, $itemdata)) {
+            $itemdata->$param = unformat_float($itemdata->$param);
+        }
+    }
+
+    // When creating a new category, a number of grade item fields are filled out automatically, and are required.
+    // If the user leaves these fields empty during creation of a category, we let the default values take effect
+    // Otherwise, we let the user-entered grade item values take effect
+    $grade_item = $grade_category->load_grade_item();
+    $grade_item_copy = fullclone($grade_item);
+    grade_item::set_properties($grade_item, $itemdata);
+
+    if (empty($grade_item->id)) {
+        $grade_item->id = $grade_item_copy->id;
+    }
+    if (empty($grade_item->grademax)) {
+        $grade_item->grademax = $grade_item_copy->grademax;
+    }
+    if (empty($grade_item->grademin)) {
+        $grade_item->grademin = $grade_item_copy->grademin;
+    }
+    if (empty($grade_item->gradepass)) {
+        $grade_item->gradepass = $grade_item_copy->gradepass;
+    }
+    if (empty($grade_item->aggregationcoef)) {
+        $grade_item->aggregationcoef = $grade_item_copy->aggregationcoef;
+    }
+
+    $grade_item->outcomeid = null;
+
+    // update hiding flag
+    if ($hiddenuntil) {
+        $grade_item->set_hidden($hiddenuntil, false);
+    } else {
+        $grade_item->set_hidden($hidden, false);
+    }
+
+    $grade_item->set_locktime($locktime); // locktime first - it might be removed when unlocking
+    $grade_item->set_locked($locked, false, true);
+
+
+    // Handle null decimals value
+    if (!array_key_exists('decimals', $itemdata) or $itemdata->decimals < 0) {
+        $grade_item->decimals = null;
+    }
+
+    $grade_item->update(); // We don't need to insert it, it's already created when the category is created
+
     // Handle user preferences
     if (isset($data->pref_aggregationview)) {
         if (!grade_report::set_pref('aggregationview', $data->pref_aggregationview, $grade_category->id)) {
@@ -119,14 +195,7 @@
 }
 
 
-$strgrades         = get_string('grades');
-$strgraderreport   = get_string('graderreport', 'grades');
-$strcategoriesedit = get_string('categoryedit', 'grades');
-$strcategory       = get_string('category', 'grades');
-
-$navigation = grade_build_nav(__FILE__, $strcategory, array('courseid' => $courseid));
-
-print_header_simple($strgrades . ': ' . $strgraderreport, ': ' . $strcategoriesedit, $navigation, '', '', true, '', navmenu($course));
+print_grade_page_head($courseid, 'edittree', null, $heading);
 
 $mform->display();
 
